<?php

namespace Ulmus\Entity\Field;

use Ulmus\Entity\EntityObjectInterface;

class Datetime extends \DateTime implements EntityObjectInterface {

    public string $format = "Y-m-d H:i:s";

    public function load(...$arguments)
    {
        $value = $arguments[0];

        try {
            # From Timestamp
            if ( is_numeric($value) ) {
                $obj = new static("@$value");
            }
            else {
                $obj = new static($value);
            }
        }
        catch(\Throwable $ex) {
            throw new \Exception(sprintf("An error occured trying to instanciate from '%s'. %s", $value, $ex->getMessage()), $ex->getCode(), $ex);
        }

        return $obj;
    }

    public function save()
    {
        return $this->__toString();
    }

    public function __toString()
    {
        return $this->format($this->format);
    }

    public function formatLocale(string $format) : string
    {
        return strftime($format, $this->getTimestamp());
    }

    public function ageAt(null|\DateTime $dateTime) : int
    {
        return (int) ( (int) ($dateTime ?: new DateTime())->format('Ymd') - (int) $this->format('Ymd') ) / 10000;
    }
}
